import PropTypes from 'prop-types';
import useDecision from '../hooks/useDecision.js';
export default function Decision(_ref) {
  var adapterId = _ref.adapterId,
    name = _ref.name,
    attributes = _ref.attributes,
    trackExperimentViewed = _ref.trackExperimentViewed,
    queryString = _ref.queryString,
    children = _ref.children;
  var data = useDecision(name, {
    attributes: attributes,
    trackExperimentViewed: trackExperimentViewed,
    queryString: queryString,
    adapterId: adapterId
  });
  return children(data);
}
Decision.propTypes = {
  name: PropTypes.string.isRequired,
  attributes: PropTypes.object,
  trackExperimentViewed: PropTypes.func,
  queryString: PropTypes.string,
  children: PropTypes.func,
  adapterId: PropTypes.string
};
Decision.displayName = 'Decision';