import PropTypes from 'prop-types';
import useFeature from '../hooks/useFeature.js';
export default function Feature(_ref) {
  var children = _ref.children,
    featureKey = _ref.featureKey,
    attributes = _ref.attributes,
    queryString = _ref.queryString,
    adapterId = _ref.adapterId,
    shouldTrackExperimentViewed = _ref.shouldTrackExperimentViewed;
  var _useFeature = useFeature(featureKey, attributes, queryString, adapterId, shouldTrackExperimentViewed),
    isActive = _useFeature.isActive,
    variables = _useFeature.variables;
  return children({
    isActive: isActive,
    variables: variables
  });
}
Feature.propTypes = {
  featureKey: PropTypes.string.isRequired,
  attributes: PropTypes.object,
  queryString: PropTypes.string,
  children: PropTypes.func,
  adapterId: PropTypes.string,
  shouldTrackExperimentViewed: PropTypes.bool
};
Feature.displayName = 'Feature';