import DefaultAdapter from './adapters/default.js';
var PDE = /*#__PURE__*/function () {
  /**
   * @constructor
   * @param {object} param
   * @param {object} param.adapter
   * @param {boolean} param.hasUserConsents
   */
  function PDE(_temp) {
    var _ref = _temp === void 0 ? {} : _temp,
      adapter = _ref.adapter,
      _ref$hasUserConsents = _ref.hasUserConsents,
      hasUserConsents = _ref$hasUserConsents === void 0 ? true : _ref$hasUserConsents;
    if (!adapter) {
      adapter = new DefaultAdapter();
    }
    this._adapter = adapter;
    this._adapter.updateConsents({
      hasUserConsents: hasUserConsents
    });
  }
  var _proto = PDE.prototype;
  _proto.getEnabledFeatures = function getEnabledFeatures(_temp2) {
    var _ref2 = _temp2 === void 0 ? {} : _temp2,
      attributes = _ref2.attributes,
      adapterId = _ref2.adapterId;
    return this._adapter.getEnabledFeatures({
      attributes: attributes,
      adapterId: adapterId
    });
  }

  /**
   * @param {object} param
   * @param {string} param.name
   * @param {object} param.attributes
   */;
  _proto.activateExperiment = function activateExperiment(_ref3) {
    var name = _ref3.name,
      attributes = _ref3.attributes,
      adapterId = _ref3.adapterId;
    return this._adapter.activateExperiment({
      name: name,
      attributes: attributes,
      adapterId: adapterId
    });
  }

  /**
   * @param {object} param
   * @param {string} param.name
   * @param {object} param.attributes
   * @param {boolean} param.isEventDisabled
   */;
  _proto.decide = function decide(_ref4) {
    var name = _ref4.name,
      attributes = _ref4.attributes,
      isEventDisabled = _ref4.isEventDisabled,
      adapterId = _ref4.adapterId;
    return this._adapter.decide({
      name: name,
      attributes: attributes,
      isEventDisabled: isEventDisabled,
      adapterId: adapterId
    });
  }

  /**
   * @param {Object} params
   * @param {function} params.onDecide
   * @returns {string} notificationId
   */;
  _proto.addDecideListener = function addDecideListener(_ref5) {
    var onDecide = _ref5.onDecide;
    return this._adapter.addDecideListener({
      onDecide: onDecide
    });
  }

  /**
   * @param {Object} params
   * @param {number} params.notificationId
   */;
  _proto.removeNotificationListener = function removeNotificationListener(_ref6) {
    var notificationId = _ref6.notificationId;
    this._adapter.removeNotificationListener({
      notificationId: notificationId
    });
  };
  _proto.getInitialData = function getInitialData() {
    return this._adapter.getInitialData();
  }

  /**
   * @param {object} param
   * @param {string} param.name
   * @param {object} param.attributes
   */;
  _proto.getVariation = function getVariation(_ref7) {
    var name = _ref7.name,
      attributes = _ref7.attributes,
      adapterId = _ref7.adapterId;
    return this._adapter.getVariation({
      name: name,
      attributes: attributes,
      adapterId: adapterId
    });
  }

  /**
   * Checks if a feature flag is active or not
   * @param {object} param
   * @param {string} param.featureKey Feature flag key
   * @parma {object=} param.attributes
   * @returns {boolean}
   */;
  _proto.isFeatureEnabled = function isFeatureEnabled(_ref8) {
    var featureKey = _ref8.featureKey,
      attributes = _ref8.attributes,
      adapterId = _ref8.adapterId;
    return this._adapter.isFeatureEnabled({
      featureKey: featureKey,
      attributes: attributes,
      adapterId: adapterId
    });
  }

  /**
   * Return all variables of a given feature
   * @param {object} param
   * @param {string} param.featureKey Feature flag key
   * @parma {object=} param.attributes
   * @returns {object}
   */;
  _proto.getAllFeatureVariables = function getAllFeatureVariables(_ref9) {
    var featureKey = _ref9.featureKey,
      attributes = _ref9.attributes,
      adapterId = _ref9.adapterId;
    return this._adapter.getAllFeatureVariables({
      featureKey: featureKey,
      attributes: attributes,
      adapterId: adapterId
    });
  };
  return PDE;
}();
export { PDE as default };